Subject: Re: linux-next: add utrace tree

From: "Frank Ch. Eigler" <[email-masked]>
Date: Sat, 23 Jan 2010 06:51:49 -0500

Hi -

On Sat, Jan 23, 2010 at 11:01:21AM +0000, Alan Cox wrote:
> [...]
> What I don't understand is why [libgdb?] doesn't solve 99% of your problem.
> ptrace is not perfect but most of the real ptrace limitations actually
> come about because either the CPU can't do something or because the
> supporting logic would be too expensive - things like having extra
> private debugger pages.

At least one reason is that ptrace is single-usage-only, so for
example you cannot concurrently debug & strace the same program.
OTOH, utrace is designed to permit clean nesting/sharing semantics for
concurrent debugger-type tools operating on the same processes.

- FChE